\documentclass[a4paper, 11pt, oneside]{scrartcl}
\usepackage{lpp}
\usepackage{verbatim}

\begin{document}

\mtitle{Project 1}

\sauthor{Rodrigo Barros Miguez}

\maff{Laboratory for Parallel Programming}{rodrigo.miguez@rwth-aachen.de}{}

\mabstract{Even though physically complex phenomena such as those involving turbulence are the
leading concerns in the today's simulations, simple problems are still important in the field.
Problems such as the steady heat transfer in a 2D plate, which is the focus of this project, are
widely used to compare the numerical solution of new schemes or numerical implementations to
its analytical solution in order to check, for example, for accucary. In this project, a Finite
Element Method based on the Galerkin formulation was used to solve the heat diffusion problem on a
circle like shape plate discretized with an unstructured mesh. For that, the RWTH cluster was used
to run the simulation, which was implemented in C++, and paraview was used to extract the results.
It was observed that the results obtained using the Galerkin method are in agreement to the
analytical temeprature distribuition for the given problem.}

\section{Introduction}

Numerical simulations have been growing in importance through the last cople of decades following
the increasing amount of computational power capabilities. Problems that were once never dream of
being solved such as the flow over an comercial airplane \cite{auth1} or the blood circulating in
vessels \cite{auth2} are now much more feasible. Furthermore, a lot of effort has been applied to
the development of a number of numerical schemes. \\
One of the most widely used numerical methods for solving partial differential equations is the
Finite Element Method, which here we are mainly interested in the Galerkin formulation. The Galerkin
finite element method has been successfully applied to solve the a diverse number of problems in
engineering and science including fluid flow \cite{auth3}, solid mechanics and vibrations
\cite{auth4, auth5}, acoustics \cite{auth6}, and many more.\\
In this project, the Galerkin finite element method was used to solve the heat diffusion problem in
a circular plate adopting an unstructed mesh. The important parts of the code implemented to obtain
the solution are presented and explained, then the results are compared to the analytical solution
and the visualization data is then depicted and discussed.

\section{Implementation and Results}

The code shown below represents the part that was implemented into the template provided. It has
three important parts: first the mass and stiffness matrix are calculated, then the boundary
conditions are set to the problem, and finally the iteration solution loop is constructed.

In the first part, the M and K matrices are declared with size of (Number of element nodes)x(Number
of element nodes), where nen is 3 in for this case. Then, the matrices are initialized to zero
followed by a nested loop based on the pseudo code provided in the project description. The mass
lumping matrix is then calculated and the matrices stored.

\begin{verbatim}

void femSolver::calculateElementMatrices(const int e)
{
    // Add code here

    double Ke[nen][nen];  // k values for all elements
    double Me[nen][nen];  // M values for all elements
    int p, i, j;

    for (i=0;i<nen;i++) {
      for (j=0;j<nen;j++) {
        Me[i][j]=0;
        Ke[i][j]=0;
      }
    }

    for (p=0;p<nGQP;p++) {
      for (i=0;i<nen;i++) {
        for (j=0;j<nen;j++) {

          Me[i][j] += ( mesh->getME(p)->getWeight() ) * ( mesh->getME(p)->getS(i) ) * \
            ( mesh->getME(p)->getS(j) ) * ( mesh->getElem(e)->getDetJ(p) );

          Ke[i][j] += ( settings->getD() ) * ( mesh->getME(p)->getWeight() ) * \
            ( mesh->getElem(e)->getDetJ(p) ) * ( ( mesh->getElem(e)->getDSdX(p,i) * \
              mesh->getElem(e)->getDSdX(p,j) ) + ( mesh->getElem(e)->getDSdY(p,i) * \
              mesh->getElem(e)->getDSdY(p,j) ) );

        }
      }
    }

    // MASS LUMPING
    double Mc[nen];
    double sumMc=0;
    double Ml[nen][nen];
    double Mee=0;

    for (i=0;i<nen;i++) {
      Mc[i]=0;
      for (j=0;j<nen;j++) {
        Ml[i][j]=0;
      }
    }

    for (i=0;i<nen;i++) {
        Mc[i]  = Me[i][i];
      for (j=0;j<nen;j++) {
        if ( i == j ) {
          sumMc += Me[i][j];
        }
        Mee += Me[i][j];
      }
    }

    for (i=0;i<nen;i++) {
      Ml[i][i] = ( Mc[i] * Mee ) / sumMc ;
    }

    // SAVING VARIABLES
    int nn=mesh->getNn();
    int myNode;

     for (i=0;i<nen;i++) {
       mesh->getElem(e)->setM(i, Ml[i][i]);
       for (j=0;j<nen;j++) {
         mesh->getElem(e)->setK(i,j,Ke[i][j]);
       }
     }

      for (j=0;j<nen;j++) {
        myNode =  mesh->getElem(e)->getConn(j);
        mesh->getNode(myNode)->addMass(Ml[j][j]);
      }

    return;
}

\end{verbatim}

The next step was to set the problem's boundary conditions. Here, since we are dealing with a circle
plate with a cavity in the middle we set the values of -100 to the inner circle and 100 to the outer
circle. In the part of the solver the T vector and the node coordinates are called using functions
that were previously implemented in the code and, after that, a nested loop between the number of
elements (outer loop) and number of element nodes (inner loop) is used to get the node ID for each
node of each element in the loop. With that it is possible to obtain the node coordinates, which are
important to check if the current node is a boundary node or inner node. It is important to notice
that boundary nodes can be of two catedories: inner boundary or outer boundary. Thus, to
differentiate two ${if}$ statements are used, where the ${x}$ and ${y}$ coordinates are used to check
whether the node is close to the boundary distance with respect to a tolerance. It is also
important to mention that this tolerance is used to void problems with numerical erros might appear
if the exact boundary distance from the center is used.

\begin{verbatim}

void femSolver::applyDrichletBC()
{
    // Add code here

    // STEP 1
    int myNode;     // node number for the current node
    double x;  // x values for all the nodes of an element
    double y;  // y values for all the nodes of an element

    triMasterElement* ME = mesh->getME(0);  // for easy access to the master element
    double * xyz = mesh->getXyz();

    double J[2][2];     // Jacobian for the current element
    double detJ;        // Jacobian determinant for the current element
    double invJ[2][2];  // inverse of Jacobian for the current element
    double dSdX[3];     // dSdx on a GQ point
    double dSdY[3];     // dSdy on a GQ point

    int ne=mesh->getNe();
    int nn=mesh->getNn();

    double * T=mesh->getT();
    double tol=4.0e-4;
    double iradSqrt=0.04;
    double oradSqrt=1.0;
    int k=0;
    int temp=0;
    for (int i=0; i<ne; i++) {
      for (int j=0; j<nen; j++) {
        myNode =  mesh->getElem(i)->getConn(j);
        x = xyz[myNode*nsd+xsd];
        y = xyz[myNode*nsd+ysd];

        if ( (x*x + y*y) < (iradSqrt + tol) ) {
          mesh->getNode(myNode)->setBCtype(1);
          T[myNode]=settings->getBC(1)->getValue1();
        }

        if( (x*x + y*y) > oradSqrt -tol ) {
          mesh->getNode(myNode)->setBCtype(1);
          T[myNode]=settings->getBC(2)->getValue1();
        }

      }
    }

    return;
}

\end{verbatim}

Finally the last part is the actual solver, where the iterations take place. Here the entire loop
was constructed as stated the pseudo code provided. First the mass and stiffness matrix are obteined
for each element in the loop, then the node ID is again obtained. From this point and on the so
called ${MTnew}$ is calculated by a new loop over the number of elements that will help the
matrix-vector multiplication to be hardcoded in a simpler way. In this step, the myNode variable
ensures that the MTnew vector is corrected filled in the correct node IDs, and also ensures that the
nodes with similar node IDs will have their temperature contributions summed.\\
After the MTnew is obtained for all nodes, the vector is devided bt the global mass and so the new
temperature vector is obtained. The new value is used to calculate the error between the temperature
values and then to store the new values to the old T array.\\
The next step in the loop is to calculate the rms error with the local error obtained in the step
before. This rms error, here defined as ${errScaled}$ is used the check for a tolerance of 1e-6 and,
if this condition is met, the loop breaks and we get the final converged solution with respect to
this criteria.

\begin{verbatim}

void femSolver::explicitSolver()
{

    // Add code here
    double * T=mesh->getT();
    int ne=mesh->getNe();
    int nn=mesh->getNn();
    double * M;
    double * K;
    double tstep=settings->getDt();
    int myNode;
    double * MTnew = mesh->getMTnew();
    int idt0, idt1;
    double * massG=mesh->getMassG();
    double errL;
    double err;
    double errInit;
    double errScaled;
    int ite;
    double Tnew[nn];
    ofstream outputFile("errorRms.csv");
    for (int ite=0;ite<settings->getNIter();ite++) {
      for (int i=0; i<ne; i++) {
        M=mesh->getElem(i)->getMptr();
        K=mesh->getElem(i)->getKptr();
        for (int n=0; n<nen; n++) {
          myNode =  mesh->getElem(i)->getConn(n);
          if (n == 0) {
            idt0 = mesh->getElem(i)->getConn(1);
            idt1 = mesh->getElem(i)->getConn(2);
            MTnew[myNode] += ((M[0] - tstep * (K[0])) * T[myNode]) + \
             (( - tstep * (K[1])) * T[idt0]) + \
              (( - tstep * (K[2])) * T[idt1]);
          }
          if (n == 1) {
            idt0 = mesh->getElem(i)->getConn(0);
            idt1 = mesh->getElem(i)->getConn(2);
            MTnew[myNode] += (( - tstep * (K[3])) * T[idt0]) + \
             ((M[1] - tstep * (K[4])) * T[myNode]) + \
              (( - tstep * (K[5])) * T[idt1]);
          }
          if (n == 2) {
            idt0 = mesh->getElem(i)->getConn(0);
            idt1 = mesh->getElem(i)->getConn(1);
            MTnew[myNode] += (( - tstep * (K[6])) * T[idt0]) + \
             (( - tstep * (K[7])) * T[idt1]) + \
              ((M[2] - tstep * (K[8])) * T[myNode]);
          }
        }
      }
      errL = 0;
      for (int i=0; i<nn;i++) {
        if (mesh->getNode(i)->getBCtype() == 0) {
          Tnew[i]=MTnew[i]/massG[i];
          errL += pow(Tnew[i]-T[i],2.0);
          T[i]=Tnew[i];
          MTnew[i]=0;
        }
      }
      err=sqrt(errL/nn);
      if (ite == 0) {
        errInit=err;
      }
      errScaled=err/errInit;
      outputFile << ite << "," << errScaled << endl;
      if (errScaled < 1e-6) {
        cout <<"Iteration: " << ite << ", Error= " << errScaled << endl;
        break;
      }
    }

    return;

}

\end{verbatim}

At this point the code was run in the RWTH cluster, for that the following commands were performed:

\begin{verbatim}

ll623449@cluster-x2:~/Project1/Skeleton[539]$ bsub < run.j
Info: Usergroup set to "p_lect0027" due to given project name "lect0027".
Job <42985443> is submitted to queue <lecture>.
ll623449@cluster-x2:~/Project1/Skeleton[540]$ bjobs
JOBID      USER    STAT  QUEUE      FROM_HOST   EXEC_HOST   JOB_NAME   SUBMIT_TIME
42985443   ll62344 PEND  lecture    cluster-x2              para-pr1   May 31 16:46
ll623449@cluster-x2:~/Project1/Skeleton[582]$ bjobs
JOBID      USER    STAT  QUEUE      FROM_HOST   EXEC_HOST   JOB_NAME   SUBMIT_TIME
42985443   ll62344 RUN   lecture    cluster-x2  bcs         para-pr1   May 31 16:46
ll623449@cluster-x2:~/Project1/Skeleton[548]$ ls
2D_Unsteady_Diffusion.cpp  CMakeLists.txt  Makefile     postProcessor.cpp  README    run.j
settings.h   solver.cpp test        tri.cpp
build        constants.h     Makefile.backup  postProcessor.h    run42985443.qout  settings.cpp
settings.in  solver.h tex-template  tri.h

\end{verbatim}

Here we see that the code generated an output file called "run42985443.qout" which is partially
presented below. We see that the solver got to the converged solution after 30127 iterations with
an rms error of 9.9977e-07 and took and total of 83.68 seconds of cpu time to run.

\begin{verbatim}

   ...

Successfully completed.

Resource usage summary:

    CPU time :                                   83.68 sec.
    Max Memory :                                 150 MB
    Average Memory :                             111.67 MB
    Total Requested Memory :                     512.00 MB
    Delta Memory :                               362.00 MB
    Max Swap :                                   -
    Max Processes :                              5
    Max Threads :                                6
    Run time :                                   91 sec.
    Turnaround time :                            142 sec.

The output (if any) follows:


==================== SETTINGS ====================
Title of the simualation              : Cylinder
Name of the minf file                 : ./mesh-cylinder/minf
Name of the mxyz file                 : ./mesh-cylinder/mxyz
Name of the mien file                 : ./mesh-cylinder/mien
Name of the mrng file                 : mrng
Name of the initial distribution file : data
Initial value of the Temperature      : 0.0000e+00
Diffusion coefficient                 : 1.0000e+00
Source term                           : 0.0000e+00
Number of maximum time steps          : 35000
Time step size                        : 2.0000e-05
                                         BCType	BCValue1	BCValue2
BC Type and values of face group 1      : 1	-1.0000e+02	0.0000e+00
BC Type and values of face group 2      : 1	1.0000e+02	0.0000e+00

====================== MESH ======================
> Number of mesh elements : 11760
> Number of nodes : 6000
> File read complete: minf
> Mesh data structure is created.
> File read complete: ./mesh-cylinder/mxyz
> File read complete: ./mesh-cylinder/mien

=================== SOLUTION =====================
Iteration: 30127, Error= 9.9977e-07

================ POST-PROCESSING =================
Tmin -1.0000e+02
Tmax 1.0000e+02
Cylinder.vtu
Elapsed time is 77.8800

\end{verbatim}

At this point the results can be obtained. For that, paraview was used to visualize the results.
In fig. 1 the temperature distribution over the entire domain is presented. One can see that the
temeprature is being transfered over the surface, since the initial temperature of the inner nodes
were all se to zero, and only the boundary nodes had a temperature assign to it. Nevertheless, for
now we cannot say anything about the accuracy of our simulation. In addition, fig. 2
presents the mesh that is being used to solve the diffusion problem.

\begin{figure}[h]
\centering
\includegraphics[width=0.9\textwidth]{../../images/temperatureDistribution.png}
\caption{Temperature distribution over the domain.}
\end{figure}

\begin{figure}[h]
\centering
\includegraphics[width=0.9\textwidth]{../../images/mesh.png}
\caption{Triangular mesh generated.}
\end{figure}

\pagebreak

The following step was to extract the temperature distribution in the axial direction. For that, a
slice was performed in the domain in paraview, where at the end only a line along the ${x}$
direction and ${y}$ equal to the origin was obtained. This methodology was used because it ensures
that no additional points are generated and only the actual mesh nodes are selected, which will make
the comparisson to the analytical results much more reliable. Otherwise, if more points are added to
the axial direction, additional errors would be introduced due to interpolation errors. Figures 3
and 4 depicted below show this step, followed by fig. 5 that shows part of the .csv file obtained
by this operation.

\begin{figure}[h]
\centering
\includegraphics[width=0.7\textwidth]{../../images/CreatePlane.png}
\caption{Line of interest being created in paraview.}
\end{figure}

\begin{figure}[h]
\centering
\includegraphics[width=0.7\textwidth]{../../images/tempDistributionPlane.png}
\caption{Temperature distribution over the line created.}
\end{figure}

\begin{figure}[h]
\centering
\includegraphics[width=0.7\textwidth]{../../images/tempProfileNew.png}
\caption{Triangular mesh generated.}
\end{figure}

\pagebreak

Since the .csv file has both, the negative and positive parts of the ${x}$ coordinate, the data was
manually modified to use only the nodes in positive coorinate values. The final values can be found
in the file "Project1/outputFiles/temperatureProfileX.csv" of the additional documents submitted
with this report.\\

The last and most important step of the results was the comparisson of the axial temperature
distribution to the analytical solution. In fig. 6 the comparisson of the two results are
presented. This figure shows that the error between the two is very small, the ${L_{2}}$ norm
between them being 0.01253, which denotes a good accuracy of the numerical scheme. Additionally, in
fig. the rms error is plotted with respect to the number of iterations.

\end{verbatim}

\begin{figure}[h]
\centering
\includegraphics[width=0.7\textwidth]{../../scripts/Tcomp.png}
\caption{Temperature distributions in the radial direction for numerical and exact solutions.}
\end{figure}

\begin{figure}[h]
\centering
\includegraphics[width=0.7\textwidth]{../../scripts/ErRms.png}
\caption{RMS error.}
\end{figure}

\pagebreak

The code used to get obtain the results depicted in fig. 6 and 7 is presented below.

\begin{verbatim}

import matplotlib.pyplot as plt
import numpy as np
import pandas as pd
import csv

# **************************************************
# Get radial temperature from numerical solution
# **************************************************

# Get the number of nodes from .csv file and allocate memory
nlines = len(pd.read_csv('temperatureProfileX.csv')) + 1
Ts = np.zeros([nlines])
r = np.zeros([nlines])

# Read temperature profile data
tempProfCSV =  csv.reader(open('temperatureProfileX.csv'),quoting=csv.QUOTE_NONNUMERIC)

# Save solution values into r and Ts (numerical temperature obtained from solver)
indx = 0
for line in tempProfCSV:
    Ts[indx] = line[0]
    r[indx] = line[1]
    indx = indx + 1

# **************************************************
# Get Error_rms/
# **************************************************

# Get the number of iterations from .csv file and allocate memory
nlines = len(pd.read_csv('errorRms.csv')) + 1
ite = np.zeros([nlines])
err = np.zeros([nlines])

# Read error rms data
errorRmsCSV =  csv.reader(open('errorRms.csv'),quoting=csv.QUOTE_NONNUMERIC)

# Save solution values into r and Ts (numerical temperature obtained from solver)
indx = 0
for line in errorRmsCSV:
    ite[indx] = line[0]
    err[indx] = line[1]
    indx = indx + 1


# **************************************************
# Calculation of Te (analytical temperature)
# **************************************************

# Definition of variables
Ti = -100
Ta = 100
ri = 0.2
ra = 1

# Calculate Te
Te = Ti - ( np.log(r) - np.log(ri) ) * (( Ti - Ta ) / ( np.log(ra) - np.log(ri) ))

# **************************************************
# L2 NORM calculation
# **************************************************

L2sum=np.sum(np.mean((Te-Ts)**2))
L2norm = np.sqrt(L2sum)
print(L2norm)

# **************************************************
# Plot of the results
# **************************************************

plt.figure(1)
plt.plot(r, Te, 'r', label='Exact Solution')
plt.plot(r, Ts, 'b+', label='Numerical Solution')

plt.xlabel('X')
plt.ylabel('Temperature')
plt.grid(True)
plt.legend()
plt.savefig("Tcomp.png")

plt.figure(2)
plt.semilogy(ite, err, 'b')

plt.xlabel('Iteration')
plt.ylabel('Error rms')
plt.grid(True)
plt.savefig("ErRms.png")
plt.show()

\end{verbatim}


\section{Conclusion}

In this project a Galerkin finite element method solver was implemented and used to solve the heat
diffusion equation for a 2D plate using a triangular mesh. The RWTH Aachen cluster was used to
compile and run the final algorithm and paraview was utilized to visualize the results. The solution
was obtained after 30127 iterations, which generated a final RMS Error of the order of 9.9977e-07. The
timing to obtain the solution using the here discribed code takes around 75 seconds in the RWTH
cluster. Additionally, the $L_{2}$ norm of the error between the final temperature distribution in the
radial direction for the numerical solution and analytical solution was of the order of 0.01253.

\bibliographystyle{unsrt}
\bibliography{literature}

\end{document}
